#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>
#include <math.h>
#include <ctype.h>
#include <limits.h>


#define xDEBUG 1

int F[110000];

int main(void)
{
int N,K,q,k,s,S,i,x,cost,n;

	for (;;) {
		i=scanf("%d %d\n",&N,&K);
		assert(i==2);
		if (N==0 && K==0)
			break;
		memset(F,0,sizeof(*F)*(N+1));
		q=1;
		for (k=0;k<K;k++) {
			i=scanf("%d",&S);
			assert(i==1);
			for (s=0;s<S;s++) {
				i=scanf("%d",&x);
				assert(i==1);
				F[x]=q++;
				}
			}
#ifdef DEBUG
		fputs("state:",stdout);
		for (n=1;n<=N;n++)
			printf(" %d",F[n]);
		putchar('\n');
#endif
		cost=0;
		for (n=1;n<=N;n++) {
int j,j2;

			if (F[n]==n || F[n]==0)
				continue;
#ifdef DEBUG
			printf("BLOCK %d\n",n);
#endif
			j=n;
			do {
				j2=F[j];
				F[j]=j;
#ifdef DEBUG
				printf("%d->%d\n",j,j2);
#endif
				j=j2;
				cost++;
				} while (j!=0 && j!=n);
			if (j!=0)
				cost++;
			else {
				F[n]=0;
				cost--;
				}
			}
		if (!cost)
			puts("No optimization needed.");
		else
			printf("We need %d move operations.\n",cost);
		}

	return 0;
}
